## sundials 5.8.0%2Bdfsg

=== examples/arkode/C_manyvector/CMakeLists.txt ===
# ---------------------------------------------------------------
# Programmer(s): Cody J. Balos @ LLNL
# ---------------------------------------------------------------
# SUNDIALS Copyright Start
# Copyright (c) 2002-2021, Lawrence Livermore National Security
# and Southern Methodist University.
# All rights reserved.
#
# See the top-level LICENSE and NOTICE files for details.
#
# SPDX-License-Identifier: BSD-3-Clause
# SUNDIALS Copyright End
# ---------------------------------------------------------------
# CMakeLists.txt file for ARKODE ManyVector examples
# ---------------------------------------------------------------

# Example lists are tuples "name\;type" where the type is
# 'develop' for examples excluded from 'make test' in releases

# Examples using SUNDIALS linear solvers
set(ARKODE_examples
  "ark_brusselator1D_manyvec\;develop"
  )

# Auxiliary files to install
set(ARKODE_extras
  plot_brusselator1D.py
  )

# Specify libraries to link against
set(ARKODE_LIB sundials_arkode)
set(NVECS_LIB sundials_nvecmanyvector sundials_nvecserial)

# Set-up linker flags and link libraries
set(SUNDIALS_LIBS ${ARKODE_LIB} ${NVECS_LIB} ${EXTRA_LINK_LIBS})

# Add the build and install targets for each ARKODE example
foreach(example_tuple ${ARKODE_examples})

  # parse the example tuple
  list(GET example_tuple 0 example)
  list(GET example_tuple 1 example_type)

  # example source files
  add_executable(${example} ${example}.c)

  set_target_properties(${example} PROPERTIES FOLDER "Examples")

  # add example to regression tests
  sundials_add_test(${example} ${example}
    ANSWER_DIR ${CMAKE_CURRENT_SOURCE_DIR}
    ANSWER_FILE ${example}.out
    EXAMPLE_TYPE ${example_type})

  # libraries to link against
  target_link_libraries(${example} ${SUNDIALS_LIBS})

  # install example source and out files
  if(EXAMPLES_INSTALL)
    install(FILES ${example}.c ${example}.out
      DESTINATION ${EXAMPLES_INSTALL_PATH}/arkode/C_manyvector)
  endif()

endforeach(example_tuple ${ARKODE_examples})

# create Makfile and CMakeLists.txt for examples
if(EXAMPLES_INSTALL)

  # Install the README file
  install(FILES README DESTINATION ${EXAMPLES_INSTALL_PATH}/arkode/C_manyvector)

  # Install the extra files
  foreach(extrafile ${ARKODE_extras})
    install(FILES ${extrafile} DESTINATION ${EXAMPLES_INSTALL_PATH}/arkode/C_manyvector)
  endforeach(extrafile ${ARKODE_extras})

  # Prepare substitution variables for Makefile and/or CMakeLists templates
  set(SOLVER "ARKODE")
  set(SOLVER_LIB "sundials_arkode")

  examples2string(ARKODE_examples EXAMPLES)

  # Regardless of the platform we're on, we will generate and install
  # CMakeLists.txt file for building the examples. This file  can then
  # be used as a template for the user's own programs.

  # generate CMakelists.txt in the binary directory
  configure_file(
    ${PROJECT_SOURCE_DIR}/examples/templates/cmakelists_serial_C_ex.in
    ${PROJECT_BINARY_DIR}/examples/arkode/C_manyvector/CMakeLists.txt
    @ONLY
    )

  # install CMakelists.txt
  install(
    FILES ${PROJECT_BINARY_DIR}/examples/arkode/C_manyvector/CMakeLists.txt
    DESTINATION ${EXAMPLES_INSTALL_PATH}/arkode/C_manyvector
    )

  # On UNIX-type platforms, we also  generate and install a makefile for
  # building the examples. This makefile can then be used as a template
  # for the user's own programs.

  if(UNIX)
    # generate Makefile and place it in the binary dir
    configure_file(
      ${PROJECT_SOURCE_DIR}/examples/templates/makefile_serial_C_ex.in
      ${PROJECT_BINARY_DIR}/examples/arkode/C_manyvector/Makefile_ex
      @ONLY
      )
    # install the configured Makefile_ex as Makefile
    install(
      FILES ${PROJECT_BINARY_DIR}/examples/arkode/C_manyvector/Makefile_ex
      DESTINATION ${EXAMPLES_INSTALL_PATH}/arkode/C_manyvector
      RENAME Makefile
      )
  endif()

  # add test_install target
  sundials_add_test_install(arkode C_manyvector)

endif()

=== examples/arkode/C_parhyp/CMakeLists.txt ===
# ---------------------------------------------------------------
# Programmer(s): Daniel R. Reynolds @ SMU
# ---------------------------------------------------------------
# SUNDIALS Copyright Start
# Copyright (c) 2002-2021, Lawrence Livermore National Security
# and Southern Methodist University.
# All rights reserved.
#
# See the top-level LICENSE and NOTICE files for details.
#
# SPDX-License-Identifier: BSD-3-Clause
# SUNDIALS Copyright End
# ---------------------------------------------------------------
# CMakeLists.txt file for ARKODE parhyp C examples
# ---------------------------------------------------------------

# Example lists are tuples "name\;nodes\;tasks\;type" where the
# type is develop for examples excluded from 'make test' in releases

# Examples using SUNDIALS linear solvers
set(ARKODE_examples
  "ark_diurnal_kry_ph\;1\;4\;develop"
#  "ark_diurnal_kry_bbd_ph\;1\;4"
  )

# Add variable ARKODE_extras with the names of auxiliary files to install
set(ARKODE_extras
  # none yet
  )

if(MPI_C_COMPILER)
  # use MPI wrapper as the compiler
  set(CMAKE_C_COMPILER ${MPI_C_COMPILER})
else()
  # add MPI_INCLUDE_PATH to include directories
  include_directories(${MPI_INCLUDE_PATH})
endif()

# Specify libraries to link against
set(ARKODE_LIB sundials_arkode)
set(NVECP_LIB sundials_nvecparhyp)

# Set-up linker flags and link libraries
set(SUNDIALS_LIBS ${ARKODE_LIB} ${NVECP_LIB} ${EXTRA_LINK_LIBS})


# Add the build and install targets for each ARKODE example
foreach(example_tuple ${ARKODE_examples})

  list(GET example_tuple 0 example)
  list(GET example_tuple 1 number_of_nodes)
  list(GET example_tuple 2 number_of_tasks)
  list(GET example_tuple 3 example_type)

  # example source files
  add_executable(${example} ${example}.c)

  set_target_properties(${example} PROPERTIES FOLDER "Examples")

  # add to regression tests
  sundials_add_test(${example} ${example}
    MPI_NPROCS ${number_of_tasks}
    ANSWER_DIR ${CMAKE_CURRENT_SOURCE_DIR}
    ANSWER_FILE ${example}.out
    EXAMPLE_TYPE ${example_type})

  # libraries to link against
  target_link_libraries(${example} ${SUNDIALS_LIBS})

  if(NOT MPI_C_COMPILER)
    target_link_libraries(${example} ${MPI_LIBRARY} ${MPI_EXTRA_LIBRARIES})
  endif()

  # install example
  if(EXAMPLES_INSTALL)
    install(FILES ${example}.c ${example}.out
      DESTINATION ${EXAMPLES_INSTALL_PATH}/arkode/C_parhyp)
  endif()

endforeach(example_tuple ${ARKODE_examples})


if(EXAMPLES_INSTALL)

  # Install the README file
  install(FILES README DESTINATION ${EXAMPLES_INSTALL_PATH}/arkode/C_parhyp)

  # Install the extra files
  foreach(extrafile ${ARKODE_extras})
    install(FILES ${extrafile} DESTINATION ${EXAMPLES_INSTALL_PATH}/arkode/C_parhyp)
  endforeach()

  # Prepare substitution variables for Makefile and/or CMakeLists templates
  set(SOLVER "ARKODE")
  set(SOLVER_LIB "sundials_arkode")

  examples2string(ARKODE_examples EXAMPLES)

  # Regardless of the platform we're on, we will generate and install
  # CMakeLists.txt file for building the examples. This file  can then
  # be used as a template for the user's own programs.

  # generate CMakelists.txt in the binary directory
  configure_file(
    ${PROJECT_SOURCE_DIR}/examples/templates/cmakelists_parhyp_C_ex.in
    ${PROJECT_BINARY_DIR}/examples/arkode/C_parhyp/CMakeLists.txt
    @ONLY
    )

  # install CMakelists.txt
  install(
    FILES ${PROJECT_BINARY_DIR}/examples/arkode/C_parhyp/CMakeLists.txt
    DESTINATION ${EXAMPLES_INSTALL_PATH}/arkode/C_parhyp
    )

  # On UNIX-type platforms, we also  generate and install a makefile for
  # building the examples. This makefile can then be used as a template
  # for the user's own programs.

  if(UNIX)
    # generate Makefile and place it in the binary dir
    configure_file(
      ${PROJECT_SOURCE_DIR}/examples/templates/makefile_parhyp_C_ex.in
      ${PROJECT_BINARY_DIR}/examples/arkode/C_parhyp/Makefile_ex
      @ONLY
      )
    # install the configured Makefile_ex as Makefile
    install(
      FILES ${PROJECT_BINARY_DIR}/examples/arkode/C_parhyp/Makefile_ex
      DESTINATION ${EXAMPLES_INSTALL_PATH}/arkode/C_parhyp
      RENAME Makefile
      )
  endif()

  # add test_install target
  sundials_add_test_install(arkode C_parhyp)

endif()

=== examples/arkode/F2003_parallel/CMakeLists.txt ===
# ---------------------------------------------------------------
# Programmer(s): David J. Gardner @ LLNL
# ---------------------------------------------------------------
# SUNDIALS Copyright Start
# Copyright (c) 2002-2021, Lawrence Livermore National Security
# and Southern Methodist University.
# All rights reserved.
#
# See the top-level LICENSE and NOTICE files for details.
#
# SPDX-License-Identifier: BSD-3-Clause
# SUNDIALS Copyright End
# ---------------------------------------------------------------
# CMakeLists.txt file for the ARKode F2003 module parallel examples
# ---------------------------------------------------------------

# Example lists are tuples "name\;nodes\;tasks\;type" where the
# type is develop for examples excluded from 'make test' in releases

# Examples using SUNDIALS linear solvers
set(FARKODE_examples
  "ark_brusselator1D_task_local_nls_f2003\;--monitor\;1\;4\;develop\;2"
  "ark_brusselator1D_task_local_nls_f2003\;--monitor --global-nls\;1\;4\;develop\;2"
  "ark_brusselator1D_task_local_nls_f2003\;--monitor --explicit --tf 3\;1\;4\;develop\;2")

if(MPI_Fortran_COMPILER)
  # use MPI wrapper as the compiler
  set(CMAKE_Fortran_COMPILER ${MPI_Fortran_COMPILER})
else()
  # add MPI_INCLUDE_PATH to include directories
  include_directories(${MPI_INCLUDE_PATH})
endif()

# Specify libraries to link against
set(ARKODE_LIBS
  sundials_arkode
  sundials_farkode_mod
  sundials_nvecmpiplusx
  sundials_fnvecmpiplusx_mod
  sundials_nvecmpimanyvector
  sundials_fnvecmpimanyvector_mod)

# Set-up linker flags and link libraries
set(SUNDIALS_LIBS ${ARKODE_LIBS} ${EXTRA_LINK_LIBS})

# Add the build and install targets for each example
foreach(example_tuple ${FARKODE_examples})

  # parse the example tuple
  list(GET example_tuple 0 example)
  list(GET example_tuple 1 example_args)
  list(GET example_tuple 2 number_of_nodes)
  list(GET example_tuple 3 number_of_tasks)
  list(GET example_tuple 4 example_type)
  list(GET example_tuple 5 example_precision)

  if(NOT TARGET ${example})
    # Install fortran modules to a unique directory to avoid naming collisions
    set(CMAKE_Fortran_MODULE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/CMakeFiles/${example}.dir)

    # example source files
    add_executable(${example} ${example}.f90)

    # libraries to link against
    target_link_libraries(${example} ${SUNDIALS_LIBS})

    set_target_properties(${example} PROPERTIES FOLDER "Examples")
  endif()

  # check if example args are provided and set the test name
  if("${example_args}" STREQUAL "")
    set(test_name ${example})
  else()
    string(REGEX REPLACE " " "_" test_name ${example}_${example_args})
  endif()

  # add example to regression tests
  sundials_add_test(${test_name} ${example}
    TEST_ARGS ${example_args}
    MPI_NPROCS ${number_of_tasks}
    ANSWER_DIR ${CMAKE_CURRENT_SOURCE_DIR}
    ANSWER_FILE ${test_name}.out
    EXAMPLE_TYPE ${example_type}
    FLOAT_PRECISION ${example_precision})

  # find all .out files for this example
  file(GLOB example_out ${example}*.out)

  # install example source and out files
  if(EXAMPLES_INSTALL)
    install(FILES ${example}.f90 ${example_out}
      DESTINATION ${EXAMPLES_INSTALL_PATH}/arkode/F2003_parallel)
  endif()

endforeach(example_tuple ${FARKODE_examples})


# create Makfile and CMakeLists.txt for examples
if(EXAMPLES_INSTALL)

  # Install the README file
  install(FILES README
    DESTINATION ${EXAMPLES_INSTALL_PATH}/arkode/F2003_parallel)

  # Install the extra files
  foreach(extrafile ${ARKODE_extras})
    install(FILES ${extrafile}
      DESTINATION ${EXAMPLES_INSTALL_PATH}/arkode/F2003_parallel)
  endforeach()

  # Prepare substitution variables for Makefile and/or CMakeLists templates
  set(SOLVER "ARKODE")

  # Makefile: convert semi-colon separated target list to space separated string
  list2string(ARKODE_LIBS EXAMPLE_LIBS)

  # CMakeLists: replace sundials_ prefix and convert to space separted string
  list(TRANSFORM ARKODE_LIBS REPLACE "sundials_" "SUNDIALS::"
    OUTPUT_VARIABLE EXAMPLES_CMAKE_TARGETS_tmp)
  list2string(EXAMPLES_CMAKE_TARGETS_tmp EXAMPLES_CMAKE_TARGETS)

  examples2string(FARKODE_examples EXAMPLES)

  # Regardless of the platform we're on, we will generate and install
  # CMakeLists.txt file for building the examples. This file  can then
  # be used as a template for the user's own programs.

  # generate CMakelists.txt in the binary directory
  configure_file(
    ${PROJECT_SOURCE_DIR}/examples/templates/cmakelists_parallel_F2003_ex.in
    ${PROJECT_BINARY_DIR}/examples/arkode/F2003_parallel/CMakeLists.txt
    @ONLY
    )

  # install CMakelists.txt
  install(
    FILES ${PROJECT_BINARY_DIR}/examples/arkode/F2003_parallel/CMakeLists.txt
    DESTINATION ${EXAMPLES_INSTALL_PATH}/arkode/F2003_parallel
    )

  # On UNIX-type platforms, we also  generate and install a makefile for
  # building the examples. This makefile can then be used as a template
  # for the user's own programs.

  if(UNIX)
    # generate Makefile and place it in the binary dir
    configure_file(
      ${PROJECT_SOURCE_DIR}/examples/templates/makefile_parallel_F2003_ex.in
      ${PROJECT_BINARY_DIR}/examples/arkode/F2003_parallel/Makefile_ex
      @ONLY
      )
    # install the configured Makefile_ex as Makefile
    install(
      FILES ${PROJECT_BINARY_DIR}/examples/arkode/F2003_parallel/Makefile_ex
      DESTINATION ${EXAMPLES_INSTALL_PATH}/arkode/F2003_parallel
      RENAME Makefile
      )
  endif()

  # add test_install target
  sundials_add_test_install(arkode F2003_parallel)

endif()

=== examples/cvode/C_openmp/CMakeLists.txt ===
# ---------------------------------------------------------------
# Programmer(s): Ting Yan @ SMU
# ---------------------------------------------------------------
# SUNDIALS Copyright Start
# Copyright (c) 2002-2021, Lawrence Livermore National Security
# and Southern Methodist University.
# All rights reserved.
#
# See the top-level LICENSE and NOTICE files for details.
#
# SPDX-License-Identifier: BSD-3-Clause
# SUNDIALS Copyright End
# ---------------------------------------------------------------
# CMakeLists.txt file for CVODE OpenMP examples
# ---------------------------------------------------------------

# Example lists are tuples "name\;args\;type" where the type is
# 'develop' for examples excluded from 'make test' in releases

# Examples using SUNDIALS linear solvers
set(CVODE_examples
  "cvAdvDiff_bnd_omp\;4\;develop"
  #"cvAdvDiffReac_kry_omp\;4\;develop"
  )

# Specify libraries to link against
set(CVODE_LIB sundials_cvode)
set(NVECOMP_LIB sundials_nvecopenmp)

if(SUNDIALS_BUILD_PACKAGE_FUSED_KERNELS)
  list(APPEND CVODE_LIB sundials_cvode_fused_stubs)
endif()

# Set-up linker flags and link libraries
set(SUNDIALS_LIBS ${CVODE_LIB} ${NVECOMP_LIB} ${EXTRA_LINK_LIBS})

# Add the build and install targets for each example
foreach(example_tuple ${CVODE_examples})

  # parse the example tuple
  list(GET example_tuple 0 example)
  list(GET example_tuple 1 example_args)
  list(GET example_tuple 2 example_type)

  # example source files
  add_executable(${example} ${example}.c)

  set_target_properties(${example} PROPERTIES FOLDER "Examples")

  # add to regression tests
  sundials_add_test(${example} ${example}
    TEST_ARGS ${example_args}
    ANSWER_DIR ${CMAKE_CURRENT_SOURCE_DIR}
    ANSWER_FILE ${example}.out
    EXAMPLE_TYPE ${example_type})

  # libraries to link against
  target_link_libraries(${example} ${SUNDIALS_LIBS})

  # install example source and out files
  if(EXAMPLES_INSTALL)
    install(FILES ${example}.c ${example}.out
      DESTINATION ${EXAMPLES_INSTALL_PATH}/cvode/C_openmp)
  endif()

endforeach(example_tuple ${CVODE_examples})


# create Makfile and CMakeLists.txt for examples
if(EXAMPLES_INSTALL)

  # Install the README file
  install(FILES README DESTINATION ${EXAMPLES_INSTALL_PATH}/cvode/C_openmp)

  # Prepare substitution variables for Makefile and/or CMakeLists templates
  set(SOLVER "CVODE")
  set(SOLVER_LIB "sundials_cvode")
  if(SUNDIALS_BUILD_PACKAGE_FUSED_KERNELS)
    set(LIBS "-lsundials_cvode_fused_stubs ${LIBS}")
  endif()

  examples2string(CVODE_examples EXAMPLES)

  # Regardless of the platform we're on, we will generate and install
  # CMakeLists.txt file for building the examples. This file  can then
  # be used as a template for the user's own programs.

  # generate CMakelists.txt in the binary directory
  configure_file(
    ${PROJECT_SOURCE_DIR}/examples/templates/cmakelists_openmp_C_ex.in
    ${PROJECT_BINARY_DIR}/examples/cvode/C_openmp/CMakeLists.txt
    @ONLY
    )

  # install CMakelists.txt
  install(
    FILES ${PROJECT_BINARY_DIR}/examples/cvode/C_openmp/CMakeLists.txt
    DESTINATION ${EXAMPLES_INSTALL_PATH}/cvode/C_openmp
    )

  # On UNIX-type platforms, we also  generate and install a makefile for
  # building the examples. This makefile can then be used as a template
  # for the user's own programs.

  if(UNIX)
    # generate Makefile and place it in the binary dir
    configure_file(
      ${PROJECT_SOURCE_DIR}/examples/templates/makefile_openmp_C_ex.in
      ${PROJECT_BINARY_DIR}/examples/cvode/C_openmp/Makefile_ex
      @ONLY
      )
    # install the configured Makefile_ex as Makefile
    install(
      FILES ${PROJECT_BINARY_DIR}/examples/cvode/C_openmp/Makefile_ex
      DESTINATION ${EXAMPLES_INSTALL_PATH}/cvode/C_openmp
      RENAME Makefile
      )
  endif()

  # add test_install target
  sundials_add_test_install(cvode C_openmp)

endif()

=== examples/cvodes/C_openmp/CMakeLists.txt ===
# ---------------------------------------------------------------
# Programmer(s): Ting Yan @ SMU
# ---------------------------------------------------------------
# SUNDIALS Copyright Start
# Copyright (c) 2002-2021, Lawrence Livermore National Security
# and Southern Methodist University.
# All rights reserved.
#
# See the top-level LICENSE and NOTICE files for details.
#
# SPDX-License-Identifier: BSD-3-Clause
# SUNDIALS Copyright End
# ---------------------------------------------------------------
# CMakeLists.txt file for CVODES OpenMP examples
# ---------------------------------------------------------------

# Example lists are tuples "name\;args\;type" where the type is
# 'develop' for examples excluded from 'make test' in releases

# Examples using SUNDIALS linear solvers
set(CVODES_examples_OMP
  "cvsAdvDiff_bnd_omp\;4\;develop"
  )

# Specify libraries to link against
set(CVODES_LIB sundials_cvodes)
set(NVECOMP_LIB sundials_nvecopenmp)

# Set-up linker flags and link libraries
set(SUNDIALS_LIBS ${CVODES_LIB} ${NVECOMP_LIB} ${EXTRA_LINK_LIBS})

# Add the build and install targets for each example
foreach(example_tuple ${CVODES_examples_OMP})

  # parse the example tuple
  list(GET example_tuple 0 example)
  list(GET example_tuple 1 example_args)
  list(GET example_tuple 2 example_type)

  # check if this example has already been added, only need to add
  # example source files once for testing with different inputs
  if(NOT TARGET ${example})
    # example source files
    add_executable(${example} ${example}.c)

    # folder to organize targets in an IDE
    set_target_properties(${example} PROPERTIES FOLDER "Examples")

    # libraries to link against
    target_link_libraries(${example} ${SUNDIALS_LIBS})
  endif()

  # add example to regression tests
  sundials_add_test(${example} ${example}
    TEST_ARGS ${example_args}
    ANSWER_DIR ${CMAKE_CURRENT_SOURCE_DIR}
    ANSWER_FILE ${example}.out
    EXAMPLE_TYPE ${example_type})

  # install example source and .out files
  if(EXAMPLES_INSTALL)
    install(FILES ${example}.c ${example}.out
      DESTINATION ${EXAMPLES_INSTALL_PATH}/cvodes/C_openmp)
  endif()

endforeach(example_tuple ${CVODES_examples_OMP})


# create Makfile and CMakeLists.txt for examples
if(EXAMPLES_INSTALL)

  # Install the README file
  install(FILES README DESTINATION ${EXAMPLES_INSTALL_PATH}/cvodes/C_openmp)

  # Install the extra files
  foreach(extrafile ${CVODES_extras_OMP})
    install(FILES ${extrafile} DESTINATION ${EXAMPLES_INSTALL_PATH}/cvodes/C_openmp)
  endforeach()

  # Prepare substitution variables for Makefile and/or CMakeLists templates
  set(SOLVER "CVODES")
  set(SOLVER_LIB "sundials_cvodes")

  examples2string(CVODES_examples_OMP EXAMPLES)

  # Regardless of the platform we're on, we will generate and install
  # CMakeLists.txt file for building the examples. This file  can then
  # be used as a template for the user's own programs.

  # generate CMakelists.txt in the binary directory
  configure_file(
    ${PROJECT_SOURCE_DIR}/examples/templates/cmakelists_openmp_C_ex.in
    ${PROJECT_BINARY_DIR}/examples/cvodes/C_openmp/CMakeLists.txt
    @ONLY
    )

  # install CMakelists.txt
  install(
    FILES ${PROJECT_BINARY_DIR}/examples/cvodes/C_openmp/CMakeLists.txt
    DESTINATION ${EXAMPLES_INSTALL_PATH}/cvodes/C_openmp
    )

  # On UNIX-type platforms, we also  generate and install a makefile for
  # building the examples. This makefile can then be used as a template
  # for the user's own programs.

  if(UNIX)
    # generate Makefile and place it in the binary dir
    configure_file(
      ${PROJECT_SOURCE_DIR}/examples/templates/makefile_openmp_C_ex.in
      ${PROJECT_BINARY_DIR}/examples/cvodes/C_openmp/Makefile_ex
      @ONLY
      )
    # install the configured Makefile_ex as Makefile
    install(
      FILES ${PROJECT_BINARY_DIR}/examples/cvodes/C_openmp/Makefile_ex
      DESTINATION ${EXAMPLES_INSTALL_PATH}/cvodes/C_openmp
      RENAME Makefile
      )
  endif()

  # add test_install target
  sundials_add_test_install(cvodes C_openmp)

endif()

=== src/ida/fcmix/CMakeLists.txt ===
# ---------------------------------------------------------------
# Programmer(s): Daniel R. Reynolds @ SMU
# ---------------------------------------------------------------
# SUNDIALS Copyright Start
# Copyright (c) 2002-2021, Lawrence Livermore National Security
# and Southern Methodist University.
# All rights reserved.
#
# See the top-level LICENSE and NOTICE files for details.
#
# SPDX-License-Identifier: BSD-3-Clause
# SUNDIALS Copyright End
# ---------------------------------------------------------------
# CMakeLists.txt file for the FIDA library
# ---------------------------------------------------------------

# Add variable fida_SOURCES with the sources for the FIDA library
set(fida_SOURCES
  fidaband.c
  fidabbd.c
  fida.c
  fidadense.c
  fidaewt.c
  fidajtimes.c
  fidanullmatrix.c
  fidanullnonlinsol.c
  fidapreco.c
  fidaroot.c
  fidasparse.c
  )

sundials_add_library(sundials_fida
  SOURCES
    ${fida_SOURCES}
  OBJECT_LIBRARIES
    sundials_fnvecserial_obj
    sundials_fsunmatrixband_obj
    sundials_fsunmatrixdense_obj
    sundials_fsunmatrixsparse_obj
    sundials_fsunlinsolband_obj
    sundials_fsunlinsoldense_obj
    sundials_fsunlinsolspbcgs_obj
    sundials_fsunlinsolspfgmr_obj
    sundials_fsunlinsolspgmr_obj
    sundials_fsunlinsolsptfqmr_obj
    sundials_fsunlinsolpcg_obj
    sundials_fsunnonlinsolnewton_obj
    sundials_fsunnonlinsolfixedpoint_obj
  LINK_LIBRARIES
    PRIVATE sundials_ida
  INCLUDE_DIRECTORIES
    PRIVATE ../
  OUTPUT_NAME
    sundials_fida
  VERSION
    ${idalib_VERSION}
  SOVERSION
    ${idalib_SOVERSION}
  STATIC_ONLY
)

#
message(STATUS "Added IDA FCMIX module")

=== src/nvector/manyvector/CMakeLists.txt ===
# ---------------------------------------------------------------
# Programmer(s): Daniel R. Reynolds @ SMU,
#                and Cody J. Balos @ LLNL
# ---------------------------------------------------------------
# SUNDIALS Copyright Start
# Copyright (c) 2002-2021, Lawrence Livermore National Security
# and Southern Methodist University.
# All rights reserved.
#
# See the top-level LICENSE and NOTICE files for details.
#
# SPDX-License-Identifier: BSD-3-Clause
# SUNDIALS Copyright End
# ---------------------------------------------------------------
# CMakeLists.txt file for the ManyVector NVECTOR library
# ---------------------------------------------------------------

# Create the sundials_nvecmanyvector library
if(BUILD_NVECTOR_MANYVECTOR)
  install(CODE "MESSAGE(\"\nInstall NVECTOR_MANYVECTOR\n\")")

  sundials_add_library(sundials_nvecmanyvector
    SOURCES
      nvector_manyvector.c
    HEADERS
      ${SUNDIALS_SOURCE_DIR}/include/nvector/nvector_manyvector.h
    INCLUDE_SUBDIR
      nvector
    OBJECT_LIBRARIES
      sundials_generic_obj
    OUTPUT_NAME
      sundials_nvecmanyvector
    VERSION
      ${nveclib_VERSION}
    SOVERSION
      ${nveclib_SOVERSION}
    )

  message(STATUS "Added NVECTOR_MANYVECTOR module")
endif()

# Create the sundials_nvecmpimanyvector library
if(BUILD_NVECTOR_MPIMANYVECTOR)
  install(CODE "MESSAGE(\"\nInstall NVECTOR_MPIMANYVECTOR\n\")")

  if(MPI_C_COMPILER)
    # use MPI wrapper as the compiler
    set(CMAKE_C_COMPILER ${MPI_C_COMPILER})
  elseif()
    # add MPI_INCLUDE_PATH to include directories
    include_directories(${MPI_INCLUDE_PATH})
  endif()

  # Create the sundials_nvecmpimanyvector library
  sundials_add_library(sundials_nvecmpimanyvector
    SOURCES
      nvector_manyvector.c
    HEADERS
      ${SUNDIALS_SOURCE_DIR}/include/nvector/nvector_mpimanyvector.h
    INCLUDE_SUBDIR
      nvector
    OBJECT_LIBRARIES
      sundials_generic_obj
    COMPILE_DEFINITIONS
      PRIVATE MANYVECTOR_BUILD_WITH_MPI
    OUTPUT_NAME
      sundials_nvecmpimanyvector
    VERSION
      ${nveclib_VERSION}
    SOVERSION
      ${nveclib_SOVERSION}
    )

  message(STATUS "Added NVECTOR_MPIMANYVECTOR module")
endif()

# Add F2003 module if the interface is enabled
if(BUILD_FORTRAN_MODULE_INTERFACE)
  add_subdirectory(fmod)
endif()

=== src/nvector/raja/CMakeLists.txt ===
# ---------------------------------------------------------------
# Programmer(s): Slaven Peles and Cody J. Balos @ LLNL
# ---------------------------------------------------------------
# SUNDIALS Copyright Start
# Copyright (c) 2002-2021, Lawrence Livermore National Security
# and Southern Methodist University.
# All rights reserved.
#
# See the top-level LICENSE and NOTICE files for details.
#
# SPDX-License-Identifier: BSD-3-Clause
# SUNDIALS Copyright End
# ---------------------------------------------------------------
# CMakeLists.txt file for the RAJA NVECTOR library
# ---------------------------------------------------------------

install(CODE "MESSAGE(\"\nInstall NVECTOR_RAJA with ${SUNDIALS_RAJA_BACKENDS} backend(s)\n\")")

if(SUNDIALS_RAJA_BACKENDS MATCHES "CUDA")
  set(_sunmemlib sundials_sunmemcuda_obj)
  set(_lib_output_name sundials_nveccudaraja)
  set_source_files_properties(nvector_raja.cpp PROPERTIES LANGUAGE CUDA)
  set(_cxx_std cxx_std_11)
elseif(SUNDIALS_RAJA_BACKENDS MATCHES "HIP")
  set(_sunmemlib sundials_sunmemhip_obj)
  set(_lib_output_name sundials_nvechipraja)
  set(_hip_lib_or_not hip::device)
  set(_cxx_std cxx_std_11)
elseif(SUNDIALS_RAJA_BACKENDS MATCHES "SYCL")
  set(_sunmemlib sundials_sunmemsycl_obj)
  set(_lib_output_name sundials_nvecsyclraja)
  set(_cxx_std cxx_std_17)
endif()

# Create the library
sundials_add_library(sundials_nvecraja
  SOURCES
    nvector_raja.cpp
  HEADERS
    ${SUNDIALS_SOURCE_DIR}/include/nvector/nvector_raja.h
  INCLUDE_SUBDIR
    nvector
  OBJECT_LIBRARIES
    sundials_generic_obj
    ${_sunmemlib}
  LINK_LIBRARIES
    PUBLIC ${_hip_lib_or_not} RAJA
  COMPILE_OPTIONS
    PUBLIC $<$<COMPILE_LANGUAGE:CUDA>:--expt-extended-lambda>
  COMPILE_DEFINITIONS
    PRIVATE ${_compile_defs}
  COMPILE_FEATURES
    PUBLIC ${_cxx_std}
  OUTPUT_NAME
    ${_lib_output_name}
  VERSION
    ${nveclib_VERSION}
  SOVERSION
    ${nveclib_SOVERSION}
)

message(STATUS "Added NVECTOR_RAJA module with ${SUNDIALS_RAJA_BACKENDS} backend")

=== src/sunlinsol/cusolversp/CMakeLists.txt ===
# ---------------------------------------------------------------
# Programmer(s): Cody J. Balos @ LLNL
# ---------------------------------------------------------------
# SUNDIALS Copyright Start
# Copyright (c) 2002-2021, Lawrence Livermore National Security
# and Southern Methodist University.
# All rights reserved.
#
# See the top-level LICENSE and NOTICE files for details.
#
# SPDX-License-Identifier: BSD-3-Clause
# SUNDIALS Copyright End
# ---------------------------------------------------------------
# CMakeLists.txt file for the cuda cuSolverSp SUNLinearSolver
# ---------------------------------------------------------------

install(CODE "MESSAGE(\"\nInstall SUNLINSOL_CUSOLVERSP\n\")")

sundials_add_library(sundials_sunlinsolcusolversp
  SOURCES
    sunlinsol_cusolversp_batchqr.cu
  HEADERS
    ${SUNDIALS_SOURCE_DIR}/include/sunlinsol/sunlinsol_cusolversp_batchqr.h
  INCLUDE_SUBDIR
    sunlinsol
  OBJECT_LIBRARIES
    sundials_generic_obj
  LINK_LIBRARIES
    PUBLIC sundials_sunmatrixcusparse ${CUDA_cusolver_LIBRARY}
    PRIVATE ${CUDA_cusparse_LIBRARY}
  OUTPUT_NAME
    sundials_sunlinsolcusolversp
  VERSION
    ${sunlinsollib_VERSION}
  SOVERSION
    ${sunlinsollib_VERSION}
)

message(STATUS "Added SUNLINSOL_CUSOLVERSP module")

=== src/sunmemory/cuda/CMakeLists.txt ===
# ---------------------------------------------------------------
# Programmer(s): Cody J. Balos @ LLNL
# ---------------------------------------------------------------
# SUNDIALS Copyright Start
# Copyright (c) 2002-2021, Lawrence Livermore National Security
# and Southern Methodist University.
# All rights reserved.
#
# See the top-level LICENSE and NOTICE files for details.
#
# SPDX-License-Identifier: BSD-3-Clause
# SUNDIALS Copyright End
# ---------------------------------------------------------------

# Create a library out of the generic sundials modules
sundials_add_library(sundials_sunmemcuda
  SOURCES
    sundials_cuda_memory.cu
  HEADERS
    ${SUNDIALS_SOURCE_DIR}/include/sunmemory/sunmemory_cuda.h
  INCLUDE_SUBDIR
    sunmemory
  OBJECT_LIB_ONLY
)

=== src/nvector/mpiplusx/fmod/CMakeLists.txt ===
# ---------------------------------------------------------------
# Programmer(s): Cody J. Balos @ LLNL
# ---------------------------------------------------------------
# SUNDIALS Copyright Start
# Copyright (c) 2002-2021, Lawrence Livermore National Security
# and Southern Methodist University.
# All rights reserved.
#
# See the top-level LICENSE and NOTICE files for details.
#
# SPDX-License-Identifier: BSD-3-Clause
# SUNDIALS Copyright End
# ---------------------------------------------------------------
# CMakeLists.txt file for the F2003 MPIPlusX NVECTOR object library
# ---------------------------------------------------------------

if(MPI_C_COMPILER)
  # use MPI wrapper as the compiler
  set(CMAKE_C_COMPILER ${MPI_C_COMPILER})
elseif()
  # add MPI_INCLUDE_PATH to include directories
  include_directories(${MPI_INCLUDE_PATH})
endif()
if(MPI_Fortran_COMPILER)
  # use MPI wrapper as the compiler
  set(CMAKE_Fortran_COMPILER ${MPI_Fortran_COMPILER})
endif()

sundials_add_f2003_library(sundials_fnvecmpiplusx_mod
  SOURCES
    fnvector_mpiplusx_mod.f90 fnvector_mpiplusx_mod.c
  OBJECT_LIBRARIES
    sundials_fgeneric_mod_obj
  OUTPUT_NAME
    sundials_fnvecmpiplusx_mod
  VERSION
    ${nveclib_VERSION}
  SOVERSION
    ${nveclib_SOVERSION}
)

message(STATUS "Added NVECTOR_MPIPLUSX F2003 interface")

=== src/nvector/parallel/fmod/CMakeLists.txt ===
# ---------------------------------------------------------------
# Programmer(s): Cody J. Balos @ LLNL
# ---------------------------------------------------------------
# SUNDIALS Copyright Start
# Copyright (c) 2002-2021, Lawrence Livermore National Security
# and Southern Methodist University.
# All rights reserved.
#
# See the top-level LICENSE and NOTICE files for details.
#
# SPDX-License-Identifier: BSD-3-Clause
# SUNDIALS Copyright End
# ---------------------------------------------------------------
# CMakeLists.txt file for the F2003 parallel NVECTOR object library
# ---------------------------------------------------------------

set(nvecparallel_SOURCES fnvector_parallel_mod.f90 fnvector_parallel_mod.c)

if(MPI_C_COMPILER)
  # use MPI wrapper as the compiler
  set(CMAKE_C_COMPILER ${MPI_C_COMPILER})
else()
  # add MPI_INCLUDE_PATH to include directories
  include_directories(${MPI_INCLUDE_PATH})
endif()

if(MPI_Fortran_COMPILER)
  # use MPI wrapper as the compiler
  set(CMAKE_Fortran_COMPILER ${MPI_Fortran_COMPILER})
else()
  # add MPI_INCLUDE_PATH to include directories
  include_directories(${MPI_INCLUDE_PATH})
endif()

sundials_add_f2003_library(sundials_fnvecparallel_mod
  SOURCES
    fnvector_parallel_mod.f90 fnvector_parallel_mod.c
  OBJECT_LIBRARIES
    sundials_fgeneric_mod_obj
  OUTPUT_NAME
    sundials_fnvecparallel_mod
  VERSION
    ${nveclib_VERSION}
  SOVERSION
    ${nveclib_SOVERSION}
)

message(STATUS "Added NVECTOR_PARALLEL F2003 interface")

=== debian/control ===
Source: sundials
Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Dima Kogan <dkogan@debian.org>,
           James Tocknell <aragilar@gmail.com>,
           Anton Gladky <gladk@debian.org>
Section: libs
Priority: optional
Build-Depends: debhelper-compat (= 13),
               pkg-config,
               chrpath,
               cmake,
               python3,
               gfortran,
               mpi-default-dev,
               libblas-dev | libblas.so,
               liblapack-dev | liblapack.so,
               petsc-dev,
               libsuitesparse-dev,
               libhypre-dev (>= 2.15.1-1exp1~)
Standards-Version: 4.5.1
Vcs-Browser: https://salsa.debian.org/science-team/sundials
Vcs-Git: https://salsa.debian.org/science-team/sundials.git
Homepage: https://www.llnl.gov/CASC/sundials/
Rules-Requires-Root: no

Package: libsundials-arkode3
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: differential equation solver (SUNDIALS library)
 This package contains the library for differential equation (ODE) system
 solvers from SUNDIALS (SUite of Nonlinear and DIfferential/ALgebraic equation
 Solvers). ARKODE is a solver for multi-rate ODE systems (initial value
 problems) given in explicit form M*dy/dt = f(t,y)

Package: libsundials-cvode4
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: ordinary differential equation solver (SUNDIALS library)
 This package contains the library for ordinary differential equation (ODE)
 system solvers from SUNDIALS (SUite of Nonlinear and DIfferential/ALgebraic
 equation Solvers). CVODE is a solver for stiff and nonstiff ODE systems
 (initial value problem) given in explicit form dy/dt = f(t,y).

Package: libsundials-cvodes4
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: ODE solver with sensistivity analysis (SUNDIALS library)
 This package contains the library for ordinary differential equation (ODE)
 system solver with sensistivity analysis capabilities from SUNDIALS (SUite of
 Nonlinear and DIfferential/ALgebraic equation Solvers). CVODES is a solver for
 stiff and nonstiff ODE systems (initial value problem) given in explicit form
 y' = f(t,y,p) with sensitivity analysis capabilities (both forward and adjoint
 modes).

Package: libsundials-ida4
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: differential-algebraic system solver (SUNDIALS library)
 This package contains the library for differential-algebraic system (IDA)
 solver from SUNDIALS (SUite of Nonlinear and DIfferential/ALgebraic equation
 Solvers).

Package: libsundials-idas3
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: IDA solver with sensitivity capabilities (SUNDIALS library)
 This package contains the library for differential-algebraic system with
 Sensitivity capabilities (IDAS) solver from SUNDIALS (SUite of Nonlinear and
 DIfferential/ALgebraic equation Solvers).

Package: libsundials-kinsol4
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: KINSOL solver (SUNDIALS library)
 This package contain the library for KINSOL (nonlinear algebraic systems)
 system solver from SUNDIALS (SUite of Nonlinear and DIfferential/ALgebraic
 equation Solvers).

Package: libsundials-nvecserial4
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Non-parallel vector operations library (SUNDIALS library)
 This package provides implementations for all vector operations
 defined by the generic NVECTOR module in the table of operations for
 SUNDIALS (SUite of Nonlinear and DIfferential/ALgebraic equation
 Solvers).
 .
 This package contains the serial flavor of the library.

Package: libsundials-nvecparallel-mpi4
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends},
         ${misc:Depends},
         mpi-default-bin
Description: MPI vector operations library (SUNDIALS library)
 This package provides implementations for all vector operations
 defined by the generic NVECTOR module in the table of operations for
 SUNDIALS (SUite of Nonlinear and DIfferential/ALgebraic equation
 Solvers).
 .
 This package contains the MPI parallel flavor of the library.

Package: libsundials-nvecparallel-pthread4
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Pthread vector operations library (SUNDIALS library)
 This package provides implementations for all vector operations
 defined by the generic NVECTOR module in the table of operations for
 SUNDIALS (SUite of Nonlinear and DIfferential/ALgebraic equation
 Solvers).
 .
 This package contains the pthread-based parallel flavor of the library.

Package: libsundials-nvecparallel-openmp4
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: OpenMP vector operations library (SUNDIALS library)
 This package provides implementations for all vector operations
 defined by the generic NVECTOR module in the table of operations for
 SUNDIALS (SUite of Nonlinear and DIfferential/ALgebraic equation
 Solvers).
 .
 This package contains the OpenMP-based parallel flavor of the library.

Package: libsundials-nvecparallel-hypre4
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: HYPRE vector operations library (SUNDIALS library)
 This package provides implementations for all vector operations
 defined by the generic NVECTOR module in the table of operations for
 SUNDIALS (SUite of Nonlinear and DIfferential/ALgebraic equation
 Solvers).
 .
 This package contains the HYPRE-based parallel flavor of the library.

Package: libsundials-nvecparallel-petsc4
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: PETSc vector operations library (SUNDIALS library)
 This package provides implementations for all vector operations
 defined by the generic NVECTOR module in the table of operations for
 SUNDIALS (SUite of Nonlinear and DIfferential/ALgebraic equation
 Solvers).
 .
 This package contains the PETSc-based parallel flavor of the library.

Package: libsundials-sunlinsol2
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: differential equation solver (SUNDIALS library)
 Auxiliary solvers used by the SUNDIALS library.

Package: libsundials-sunmatrix2
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: differential equation solver (SUNDIALS library)
 Auxiliary solvers used by the SUNDIALS library.

Package: libsundials-dev
Architecture: any
Section: libdevel
Depends: libsundials-arkode3               (= ${binary:Version}),
         libsundials-cvode4                (= ${binary:Version}),
         libsundials-cvodes4               (= ${binary:Version}),
         libsundials-ida4                  (= ${binary:Version}),
         libsundials-idas3                 (= ${binary:Version}),
         libsundials-kinsol4               (= ${binary:Version}),
         libsundials-nvecserial4           (= ${binary:Version}),
         libsundials-nvecparallel-mpi4     (= ${binary:Version}),
         libsundials-nvecparallel-pthread4 (= ${binary:Version}),
         libsundials-nvecparallel-openmp4  (= ${binary:Version}),
         libsundials-nvecparallel-hypre4   (= ${binary:Version}),
         libsundials-nvecparallel-petsc4   (= ${binary:Version}),
         libsundials-sunlinsol2            (= ${binary:Version}),
         libsundials-sunmatrix2            (= ${binary:Version}),
         cmake,
         mpi-default-dev,
         libhypre-dev,
         petsc-dev,
         gfortran,
         pkg-config,
         ${misc:Depends}
Breaks: libsundials-serial-dev
Replaces: libsundials-serial-dev
Description: Package providing everything for SUNDIALS dev work
 This package contains all development files necessary to build applications
 using SUNDIALS (SUite of Nonlinear and DIfferential/ALgebraic equation
 Solvers). All examples and documentation links live in this package as well.
